using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;

namespace AZ_CallerID
{
    class TelnetConnection
    {
        TcpClient tcpSocket;

        int TimeOutMs = 100;

        public bool IsConnected
        {
            get { return tcpSocket.Connected; }
        }


        public TelnetConnection(string Hostname, int Port)
        {
            tcpSocket = new TcpClient(Hostname, Port);
        }
        

        public string Read()
        {
            if (!tcpSocket.Connected) return null;
            StringBuilder sb = new StringBuilder();
            do
            {
               ParseTelnet(sb);
                System.Threading.Thread.Sleep(TimeOutMs);
            } while (tcpSocket.Available > 0);
            return sb.ToString();
        }


        void ParseTelnet(StringBuilder sb)
        {
            while (tcpSocket.Available > 0)
            {
                int input = tcpSocket.GetStream().ReadByte();
                switch (input)
                {
                    case -1:
                        break;
                    default:
                        sb.Append((char)input);
                        break;
                }
            }
        }

    }
}
